
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Node.js开发入门—Stream用法详解 / 憋错料</title>

    <meta name="description" content="Node.js开发入门—Stream用法详解 Stream是Node.js中非常重要的一个模块,应用广泛.一个流是一个具备了可读.可写或既可读又可写能力的接口,通过这些接口,我们可以和磁盘文件.套接字.HTTP请求来交互,实现数据从一个地方流动到另一个地方的功能. 所有的流都实现了EventEmitter的接口,具备事件能力,通过发射事件来反馈流的状态.比如有错误发生时会发射&quot;error&quot;事件,有数据可被读取时发射&quot;data&quot;事件.这样我们就可以注册监听器来处理某个事件,达到我们的目的. Node.j ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Node.js开发入门—Stream用法详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><a href="https://nodejs.org/api/stream.html" rel="external nofollow noreferrer"><strong>Stream</strong></a>是Node.js中非常重要的一个模块，应用广泛。一个流是一个具备了可读、可写或既可读又可写能力的接口，通过这些接口，我们可以和磁盘文件、套接字、HTTP请求来交互，实现数据从一个地方流动到另一个地方的功能。</p>
<p>所有的流都实现了EventEmitter的接口，具备事件能力，通过发射事件来反馈流的状态。比如有错误发生时会发射“error”事件，有数据可被读取时发射“data”事件。这样我们就可以注册监听器来处理某个事件，达到我们的目的。</p>
<p>Node.js定义了Readable、Writable、Duplex、Transform四种流，Node.js有各种各样的模块，分别实现了这些流，我们挑出来一一看一看他们的用法。当然，我们也可以实现自己的流，可以参考Stream的文档或我们即将提到的这些Node.js里的实现。</p>
<h1>Readable</h1>
<p>Readable流提供了一种将外部来源（比如文件、套接字等）的数据读入到应用程序的机制。</p>
<p>可读的流有两种模式：流动模式和暂停模式。流动模式下，数据会自动从来源流出，跟不老泉似的，直到来源的数据耗尽。暂停模式下，你得通过stream.read()主动去要数据，你要了它才从来源读，你不要它就在那儿耗着等你。</p>
<p>可读流在创建时都是暂停模式。暂停模式和流动模式可以互相转换。</p>
<p>要从暂停模式切换到流动模式，有下面三种办法：</p>
<ul>
<li>给“data”事件关联了一个处理器</li>
<li>显式调用resume()</li>
<li>调用pipe()将可读流桥接到一个可写流上</li>
</ul>
<p>要从流动模式切换到暂停模式，有两种途径：</p>
<ul>
<li>如果这个可读的流没有桥接可写流组成管道，直接调用pause()</li>
<li>如果这个可读的流与若干可写流组成了管道，需要移除与“data”事件关联的所有处理器，并且调用unpipe()方法断开所有管道。</li>
</ul>
<p>需要注意的是，出于向后兼容的原因，移除“data”事件的处理器，可读流并不会自动从流动模式转换到暂停模式；还有，对于已组成管道的可读流，调用pause也不能保证这个流会转换到暂停模式。</p>
<p>Readable流的一些常见实例如下：</p>
<ul>
<li>客户端的HTTP响应</li>
<li>服务端的HTTP请求</li>
<li>fs读取流</li>
<li>zlib流</li>
<li>crypto（加密）流</li>
<li>TCP套接字</li>
<li>子进程的stdout和stderr</li>
<li>process.stdin</li>
</ul>
<p>Readable流提供了以下事件：</p>
<ul>
<li>readable：在数据块可以从流中读取的时候发出。它对应的处理器没有参数，可以在处理器里调用read([size])方法读取数据。</li>
<li>data：有数据可读时发出。它对应的处理器有一个参数，代表数据。如果你只想快快地读取一个流的数据，给data关联一个处理器是最方便的办法。处理器的参数是Buffer对象，如果你调用了Readable的setEncoding(encoding)方法，处理器的参数就是String对象。</li>
<li>end：当数据被读完时发出。对应的处理器没有参数。</li>
<li>close：当底层的资源，如文件，已关闭时发出。不是所有的Readable流都会发出这个事件。对应的处理器没有参数。</li>
<li>error：当在接收数据中出现错误时发出。对应的处理器参数是<a href="https://nodejs.org/api/errors.html#errors_class_error" rel="external nofollow noreferrer">Error</a>的实例，它的message属性描述了错误原因，stack属性保存了发生错误时的堆栈信息。</li>
</ul>
<p>Readable还提供了一些函数，我们可以用它们读取或操作流：</p>
<ul>
<li>read([size])：如果你给read方法传递了一个大小作为参数，那它会返回指定数量的数据，如果数据不足，就会返回null。如果你不给read方法传参，它会返回内部缓冲区里的所有数据，如果没有数据，会返回null，此时有可能说明遇到了文件末尾。read返回的数据可能是Buffer对象，也可能是String对象。</li>
<li>setEncoding(encoding)：给流设置一个编码格式，用于解码读到的数据。调用此方法后，read([size])方法返回String对象。</li>
<li>pause()：暂停可读流，不再发出data事件</li>
<li>resume()：恢复可读流，继续发出data事件</li>
<li>pipe(destination,[options])：把这个可读流的输出传递给destination指定的Writable流，两个流组成一个管道。options是一个JS对象，这个对象有一个布尔类型的end属性，默认值为true，当end为true时，Readable结束时自动结束Writable。注意，我们可以把一个Readable与若干Writable连在一起，组成多个管道，每一个Writable都能得到同样的数据。这个方法返回destination，如果destination本身又是Readable流，就可以级联调用pipe（比如我们在使用gzip压缩、解压缩时就会这样，马上会讲到）。</li>
<li>unpipe([destination])：端口与指定destination的管道。不传递destination时，断开与这个可读流连在一起的所有管道。</li>
</ul>
<p>好吧，大概就这些了，我们来举一个简单的使用Readable的例子。以<a href="https://nodejs.org/api/fs.html" rel="external nofollow noreferrer">fs</a>模块为例吧。</p>
<p>fs.ReadStream实现了stream.Readable，另外还提供了一个“open”事件，你可以给这个事件关联处理器，处理器的参数是文件描述符（一个整型数）。</p>
<p>fs.createReadStream(path[, options])用来打开一个可读的文件流，它返回一个fs.ReadStream对象。path参数指定文件的路径，可选的options是一个JS对象，可以指定一些选项，类似下面这样：</p>
<pre><code>{ flags: ‘r‘,
  encoding: ‘utf8‘,
  fd: null,
  mode: 0666,
  autoClose: true }
</code></pre>
<p>options的flags属性指定用什么模式打开文件，’w’代表写，’r’代表读，类似的还有’r+’、’w+’、’a’等，与Linux下的open函数接受的读写模式类似。encoding指定打开文件时使用编码格式，默认就是“utf8”，你还可以为它指定”ascii”或”base64”。fd属性默认为null，当你指定了这个属性时，createReadableStream会根据传入的fd创建一个流，忽略path。另外你要是想读取一个文件的特定区域，可以配置start、end属性，指定起始和结束（包含在内）的字节偏移。autoClose属性为true（默认行为）时，当发生错误或文件读取结束时会自动关闭文件描述符。</p>
<p>OK，背景差不多了，可以上代码了，readable.js文件内容如下：</p>
<pre><code>var fs = require(‘fs‘);

var readable = fs.createReadStream(‘readable.js‘,{
  flags: ‘r‘,
  encoding: ‘utf8‘,
  autoClose: true,
  mode: 0666,
});

readable.on(‘open‘, function(fd){
  console.log(‘file was opened, fd - ‘, fd);
});

readable.on(‘readable‘, function(){
  console.log(‘received readable‘);
});

readable.on(‘data‘, function(chunk){
  console.log(‘read %d bytes: %s‘, chunk.length, chunk);
});

readable.on(‘end‘, function(){
  console.log(‘read end‘);
});

readable.on(‘close‘, function(){
  console.log(‘file was closed.‘);
});

readable.on(‘error‘, function(err){
  console.log(‘error occured: %s‘, err.message);
});
</code></pre>
<p>示例代码把readable.js的内容读取出来，关联了各种事件，演示了读取文件的一般用法。</p>
<h1>Writable</h1>
<p>Writable流提供了一个接口，用来把数据写入到目的设备（或内存）中。Writable流的一些常见实例：</p>
<ul>
<li>客户端的HTTP请求</li>
<li>服务器的HTTP响应</li>
<li>fs写入流</li>
<li>zlib流</li>
<li>crypto（加密）流</li>
<li>TCP套结字</li>
<li>子进程的stdin</li>
<li>process.stdout和process.stderr</li>
</ul>
<p>Writable流的write(chunk[,encoding] [,callback])方法可以把数据写入流中。其中，chunk是待写入的数据，是Buffer或String对象。这个参数是必须的，其它参数都是可选的。如果chunk是String对象，encoding可以用来指定字符串的编码格式，write会根据编码格式将chunk解码成字节流再来写入。callback是数据完全刷新到流中时会执行的回调函数。write方法返回布尔值，当数据被完全处理后返回true（不一定是完全写入设备哦）。</p>
<p>Writable流的end([chunk] [,encoding] [,callback])方法可以用来结束一个可写流。它的三个参数都是可选的。chunk和encoding的含义与write方法类似。callback是一个可选的回调，当你提供它时，它会被关联到Writable的finish事件上，这样当finish事件发射时它就会被调用。</p>
<p>Writable还有setDefaultEncoding等方法，具体可以参考在线文档。</p>
<p>现在我们来看看Writable公开的事件：</p>
<ul>
<li>finish： 在end()被调用、所有数据都已被写入底层设备后发射。对应的处理器函数没有参数。</li>
<li>pipe： 当你在Readable流上调用pipe()方法时，Writable流会发射这个事件，对应的处理器函数有一个参数，类型是Readable，指向与它连接的那个Readable流。</li>
<li>unpipe： 当你在Readable流上调用unpipe()方法时，Writable流会发射这个事件，对应的处理器函数有一个参数，类型是Readable，指向与刚与它断开连接的那个Readable流。</li>
<li>error： 出错时发射，对应的处理器函数的参数是<a href="https://nodejs.org/api/errors.html#errors_class_error" rel="external nofollow noreferrer">Error</a>对象。</li>
</ul>
<p>OK，让我们来举两个小例子。一个是fs的，一个是socket的。</p>
<p>fs.createWriteStream(path[,options])用来创建一个可写的文件流，它返回fs.WriteStream对象。第一个参数path是路径，第二个参数options是JS对象，是可选的，指定创建文件时的选项，类似：</p>
<pre><code>{ flags: ‘w‘,
  defaultEncoding: ‘utf8‘,
  fd: null,
  mode: 0666 }
</code></pre>
<p>defaultEncoding指定默认的文本编码。前面讲fs.createReadStream时提到了。</p>
<p>writeFile.js内容如下：</p>
<pre><code>var fs = require(‘fs‘);

var writable = fs.createWriteStream(‘example.txt‘,{
  flags: ‘w‘,
  defaultEncoding: ‘utf8‘,
  mode: 0666,
});

writable.on(‘finish‘, function(){
  console.log(‘write finished‘);
  process.exit(0);
});

writable.on(‘error‘, function(err){
  console.log(‘write error - %s‘, err.message);
});

writable.write(‘My name is 火云邪神‘, ‘utf8‘);

writable.end();
</code></pre>
<p>很简单的一个示例，注意writeFile.js的文件编码格式要是UTF8哦。</p>
<p>下面看一个使用TCP套接字的示例，echoServer2.js内容如下：</p>
<pre><code>var net = require("net");

var server = net.createServer(function(sock){
  sock.setEncoding(‘utf8‘);
  sock.on(‘pipe‘, function(src){
    console.log(‘piped‘);
  });
  sock.on(‘error‘, function(err){
    console.log(‘error - %s‘, err.message);
  });
  sock.pipe(sock);
});

server.maxConnections = 10;
server.listen(7, function(){
  console.log(‘echo server bound at port - 7‘);
});
</code></pre>
<p>上面的echoServer功能和我们之前在<a href="http://blog.csdn.net/foruok/article/details/48434277" rel="external nofollow noreferrer">Node.js开发入门——套接字(socket)编程</a>中的echoServer一样。不同的是，这里使用了pipe方法，而那个版本监听data事件，调用write方法将收到的数据回写给客户端。</p>
<p>sock.Socket是Duplex流，既实现了Readable又实现了Writable，所以，sock.pipe(sock)是正确的调用。</p>
<p>常见的Duplex流有：</p>
<ul>
<li>TCP socket</li>
<li>zlib</li>
<li>crypto</li>
</ul>
<p>Duplex是Readable和Writable的合体。</p>
<h1>Transform</h1>
<p>Transform扩展了Duplex流，它会修改你使用Writable接口写入的数据，当你用Readable接口来读时，数据已经发生了变化。</p>
<p>比较常见的Transform流有：</p>
<ul>
<li>zlib</li>
<li>crypto</li>
</ul>
<p>好啦，我们举一个简单的示例，使用<a href="https://nodejs.org/api/zlib.html" rel="external nofollow noreferrer">zlib</a>模块来压缩和解压缩。示例文件是zlibFile.js，内容如下：</p>
<pre><code>var zlib = require("zlib");
var gzip = zlib.createGzip();
var fs = require(‘fs‘);
var inFile = fs.createReadStream(‘readable.js‘);
var outGzip = fs.createWriteStream(‘readable.gz‘);
//inFile - Readable
//gzip - Transform(Readable &amp;&amp; Writable)
//outFile - Writable
inFile.pipe(gzip).pipe(outGzip);

setTimeout(function(){
  var gunzip = zlib.createUnzip({flush: zlib.Z_FULL_FLUSH});
  var inGzip = fs.createReadStream(‘readable.gz‘);
  var outFile = fs.createWriteStream(‘readable.unzipped‘);
  inGzip.pipe(gunzip).pipe(outFile);
}, 5000);
</code></pre>
<p>上面的示例比较简单，使用了zlib模块，文档在这里：<a href="https://nodejs.org/api/zlib.html" rel="external nofollow noreferrer">https://nodejs.org/api/zlib.html</a>。</p>
<p>接下来我们来实现一个Transform流，把输入数据中的小写字母转换为大写字母。我们代码在upperTransform.js里，内容如下：</p>
<pre><code>var fs = require(‘fs‘);
var util = require(‘util‘);
var stream = require(‘stream‘);
util.inherits(UpperTransform, stream.Transform);

function UpperTransform(opt){
  stream.Transform.call(this, opt);
}

UpperTransform.prototype._transform = function(chunk, encoding, callback){
  var data = new Buffer(chunk.length);
  var str = chunk.toString(‘utf8‘);
  for(var i = 0, offset=0; i &lt; str.length; i++){
    if(/^[a-z]+$/.test(str[i])){
      offset += data.write(str[i].toUpperCase(), offset);
    }else{
      offset += data.write(str[i], offset);
    }
  }
  this.push(data);
  callback();
}

UpperTransform.prototype._flush = function(cb){
  cb();
}

var upper = new UpperTransform();
var inFile = fs.createReadStream(‘example.txt‘);
inFile.setEncoding(‘utf8‘);
var outFile = fs.createWriteStream(‘exampleUpper.txt‘,{defaultEncoding: ‘utf8‘});

inFile.pipe(upper).pipe(outFile);
</code></pre>
<p>为了实现自定义的Transform，需要先继承Transform流的功能。实现这一点最简单的办法就是使用<a href="https://nodejs.org/api/util.html" rel="external nofollow noreferrer">util模块</a>的inherits()方法，然后在你的构造器里调用使用call方法把父对象应用到当前对象上。代码就是下面这部分：</p>
<pre><code>util.inherits(UpperTransform, stream.Transform);
function UpperTransform(opt){
  stream.Transform.call(this, opt);
}
</code></pre>
<p>继承了stream.Transform之后，实现_transform和_flush即可。在_transform里，我们先创建了一个缓冲区，然后把传入的数据（chunk）转换成字符串（写死为utf8了），接着遍历字符串，遇见小写字母就转换一下，写入创建的缓冲区里，完成转换后，调用push方法，把转换后的数据加到内部的数据队列中。</p>
<p>其它的就比较简单了。注意，作为示例，我们只转换utf8编码的文本文件。</p>
<hr>
<br />其它文章：</p>
<ul>
<li><a href="http://blog.csdn.net/foruok/article/details/48967641" rel="external nofollow noreferrer">Node.js开发入门——Buffer用法详解</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48780135" rel="external nofollow noreferrer">Node.js开发入门——语音合成示例</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48572053" rel="external nofollow noreferrer">Node.js开发入门——UDP编程</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48488515" rel="external nofollow noreferrer">Node.js开发入门——使用http访问外部世界</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48434277" rel="external nofollow noreferrer">Node.js开发入门——套接字(socket)编程</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48366765" rel="external nofollow noreferrer">Node.js开发入门——notepad++ for Node.js</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48231175" rel="external nofollow noreferrer">Node.js开发入门——使用对话框ngDialog</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/48173377" rel="external nofollow noreferrer">Node.js开发入门——引入UIBootstrap</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47774665" rel="external nofollow noreferrer">Node.js开发入门——用MongoDB改造LoginDemo</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47746057" rel="external nofollow noreferrer">Node.js开发入门——MongoDB与Mongoose</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47719063" rel="external nofollow noreferrer">Node.js开发入门——使用cookie保持登录</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47678259" rel="external nofollow noreferrer">Node.js开发入门——使用AngularJS内置服务</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47652389" rel="external nofollow noreferrer">Node.js开发入门——Angular简单示例</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47592155" rel="external nofollow noreferrer">Node.js开发入门——使用AngularJS</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47413907" rel="external nofollow noreferrer">Node.js开发入门——使用jade模板引擎</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47354737" rel="external nofollow noreferrer">Node.js开发入门——Express里的路由和中间件</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47333299" rel="external nofollow noreferrer">Node.js开发入门——Express安装与使用</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47310425" rel="external nofollow noreferrer">Node.js开发入门——HTTP文件服务器</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47283775" rel="external nofollow noreferrer">Node.js开发入门——HelloWorld再分析</a></li>
<li><a href="http://blog.csdn.net/foruok/article/details/47214373" rel="external nofollow noreferrer">Node.js开发入门——环境搭建与HelloWorld</a></li>
</ul>
<p>版权声明：本文为foruok原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:49:45 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/node-js/" title="node&period;js">node&period;js</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6%e4%bc%a0%e8%be%93/" title="文件传输">文件传输</a>, <a href="https://www.biecuoliao.com/tag/http%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="http服务器">http服务器</a>, <a href="https://www.biecuoliao.com/tag/%e6%b5%81%e6%8e%a5%e5%8f%a3/" title="流接口">流接口</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Node.js开发入门—Stream用法详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YL7ywM.html" rel="bookmark">Node&period;js开发入门&mdash;HTTP文件服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HelloWorld示例只有演示意义,这次我们来搞一个实际的例子:文件服务器.我们使用Node.js创建一个HTTP协议的文件服务器,你可以使用浏览器或其它下载工具到文件服务器上下载文件. 用Node.js实现的HTTP文件服务器,比我在Qt网络编程实战之HTTP服务器视频课程里用Qt实现的版本,复杂度要小太多太多了. 为了读取文件,我们会用到File System模块(名字是&quot;fs&quot;),Stream,我们还要分析URL,区别HTTP方法,还会用到EventEmitter. 文件服务器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rvYLb3.html" rel="bookmark">Node&period;js开发入门&mdash;使用对话框ngDialog</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做网站经常会遇到弹出对话框获取用户输入或弹出对话框让用户确认某个操作之类的情景,有一个基于AngularJS的扩展模块可以帮我们优雅地完成这类事情:ngDialog. ngDialog在github上提供了一个示例网页,演示了它的各种用法,在这里:https://github.com/likeastore/ngDialog/blob/master/example/index.html.ngDialog的github主页的readme也对常用的指令和服务做了较为详细的介绍,可以参考.我这篇就纯粹是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j1lqeM.html" rel="bookmark">Node&period;js开发入门&mdash;Angular简单示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在&quot;使用AngularJS&quot;中,我们提到了如何在Node.js项目中引入AngularJS,这次提供一个非常简单的示例,演示AngularJS里的指令.数据绑定.服务等内容. 我准备做Web后台管理系统,不同的管理员会有不同的权限,管理员登录后看到的菜单和他的权限有关,能看到什么,是动态生成的(类似RBAC).本文的示例从这个项目而来,当然,现在还是最简单的. 如果没有特别说明,后面我们用到的示例都使用express generator生成. Angular小demo 先搞起来吧. 第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AE1yg4.html" rel="bookmark">Node&period;js开发入门&mdash;使用http访问外部世界</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Node.js的http模块,不但可以构建服务器,也可以作为客户端类库来访问别的服务器.关键就在两个方法: http.request(options[,callback]) http.get(path[,callback]) 除了http,还会用到FileSystem模块和Stream中的stream.Readable和stream.Writable. 先来大概介绍一下相关API吧. API解释 http.request()方法接受一个options参数,这个参数可以是对象,用来指明你要访问的网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEWdyX3.html" rel="bookmark">Node&period;js开发入门&mdash;套接字&lpar;socket&rpar;编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Node.js的net模块提供了socket编程接口,方便我们利用较为底层的套接字接口来实现应用协议.这次我们看一个简单的回显服务器示例,包括服务端和客户端的代码. 使用JavaScript也可以进行套接字编程,哈哈,这酸爽! 代码 分服务器和客户端两部分来说吧. echoServer代码分析 echoServer.js: var net = require(&quot;net&quot;); // server is an instance of net.Server // sock is an ins			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JvN1D4.html" rel="bookmark">Node&period;js开发入门&mdash;notepad&plus;&plus; for Node&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于Node.js开发,论IDE的话,Webstorm是不二的选择,但它是收费的(可免费使用30天).一开始,我们先将就一下,使用notepad++来编写Node.js应用.这样做还有一大好处:没有关于Node.js的代码高亮和自动补全,可以更好地敦促我们使用在线API文档记忆各种类库API.死磕自己吧,enjoy it. notepad++的安装与配置 到&quot;https://notepad-plus-plus.org/download/v6.8.2.html&quot;这里下载吧,6.8.2版本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rn8dR0.html" rel="bookmark">Node&period;js开发入门&mdash;使用AngularJS内置服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇,&quot;AngularJS简单示例&quot;中演示了一个非常简单的使用Angular的小demo,那篇已经太长,原本要介绍的一些内容只好单另开篇了.这些内容,就是如何使用Angular服务. 我们还是基于&quot;AngularJS简单示例&quot;中的示例来改造一下.新的示例,能从Node.js+Express构造的服务器上获取管理菜单.为了实现这个,需要做几部分改造: 服务器提供adminMenu的下载功能,需要修改app.js,处理路由 修改Angular实现的控制器x-cont			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/351kgo3.html" rel="bookmark">Node&period;js开发入门&mdash;&mdash;MongoDB与Mongoose</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了保存网站的用户数据和业务数据,通常需要一个数据库.MongoDB和Node.js特别般配,因为MongoDB是基于文档的非关系型数据库,文档是按BSON(JSON的轻量化二进制格式)存储的,增删改查等管理数据库的命令和JavaScript语法很像.如果你在Node.js里访问MongoDB的数据,会有我们是一家人的感觉,特别亲切. 我也准备使用MongoDB来作为我的数据库. MongoDB使用集合(collection)和文档(document)来描述和存储数据,collection就相当			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AW8Xg0.html" rel="bookmark">Node&period;js开发入门&mdash;使用cookie保持登录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这次来做一个网站登录的小例子,后面会用到.这个示例会用到Cookie.HTML表单.POST数据体(body)解析. 第一个版本,我们的用户数据就写死在js文件里.第二个版本会引入MongoDB来保存用户数据. 示例准备 1. 使用express创建应用 就下面的命令序列: express LoginDemo cd LoginDemo npm install 2. 登录页面 登录页面的jade模板为login.jade,内容如下: doctype html html head meta(char			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9ME6JZ0.html" rel="bookmark" class="title">大话设计模式-第八章-工厂方法模式</a>
					<div>
						一.UML图 二.包含的角色 (1)抽象工厂 (2)具体工厂 (3)抽象产品 (4)具体产品 三.优势 (1)工厂方法模式是对简单工厂模式的稍微的改进.工厂方法模式的用意是定义一个创建产品对象的工厂接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qDXG0.html" rel="bookmark" class="title">tee命令用法</a>
					<div>
						用途说明 在执行Linux命令时,我们可以把输出重定向到文件中,比如 ls &gt;a.txt,这时我们就不能看到输出了,如果我们既想把输出保存到文件中,又想在屏幕上看到输出内容,就可以使用tee命令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMz6LdM.html" rel="bookmark" class="title">一卖淫团伙被端：失足女装路人等车 客人在车内挑选t1</a>
					<div>
						打算咋办是质量相当不错丑闻中逐渐的要情绪激动球捅给这些球员可不认为肖卿的紧张帕德博恩比赛一开始霍芬海姆就加强了孩子进足球学校突出自己的够取得更大的希望肖卿好的他们才能是会多么的忽然肖卿感觉到了看起来本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGgda4.html" rel="bookmark" class="title">1005&period; Spell It Right &lpar;20&rpar;&lpar;模拟题&rpar;</a>
					<div>
						Given a non-negative integer N, your task is to compute the sum of all the digits of N, and output e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGrzxM.html" rel="bookmark" class="title">2014-11-10 关于C&num; 如何获取本地电脑的UTC时区</a>
					<div>
						  首先庆祝一下 我竟然在这C#公司做了一年了还没被炒 然后在吐槽一下万恶的需求 本来今天的是要获取UTC时区的 花了1小时的时间去百度搜索,现在就来分享一下 结果吧!发现C# 本身有一个System ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8wb13.html" rel="bookmark" class="title">自动化收集SQLSERVER诊断信息</a>
					<div>
						自动化收集SQLSERVER诊断信息 相信很多人都遇到过当SQLSERVER出现问题的时候,而你又解决不了需要DBA或者微软售后支持工程师 去帮忙解决问题,那么他们一般需要你收集一些系统信息和SQLS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAXeN4.html" rel="bookmark" class="title">linux 常用基础命令 tar 详细介绍</a>
					<div>
						[命令介绍] tar命令可以为linux的文件和目录创建档案.利用tar,可以为某一特定文件创建档案(备份文件),也可以在档案中改变文件,或者向档案中加入新的文件.tar最初被用来在磁带上创建档案,现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomDXy3.html" rel="bookmark" class="title">Spring-Batch CSV文件读取时的注意点</a>
					<div>
						按照Spring Batch 之 Sample(CSV文件操作)(四) 的方式配置好csvItemReader, 发现读入的数据很是奇怪,通过修改配置文件发现, commit-interval=&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPb1Q0.html" rel="bookmark" class="title">随笔：做一个平庸程序员，are you scared？</a>
					<div>
						背景: 一个平庸程序员的自白.近期看到的少有的好文,细细品味,感触良多,思来想去不知如何与作者交流.无论从工作经验,还是从境界,都与原作与译作有一段差距.但很多人都会有相似的经历,说出自己的故事,彼此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONgkr0.html" rel="bookmark" class="title">request与response对象&period;</a>
					<div>
						request与response对象. 1. request代表请求对象 response代表的响应对象. 学习它们我们可以操作http请求与响应. 2.request,response体系结构. 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVVpVjM.html" rel="bookmark" class="title">web标准&lpar;复习&rpar;--1</a>
					<div>
						XHTML CSS基础知识 一.xhtml css基础知识首先说一下我们这节课的知识点 1.文档类型 2.语言编码 3.html标签 4.css样式 5.css优先级 6.css盒模型组成 1)文档类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZnb13.html" rel="bookmark" class="title">两个char类型的变量的值持平</a>
					<div>
						恰是由于字符串不是根本类型.而且有时候还会由于地址不持平呈现过错的操作,所以要对字符串进行相关操作时会对比费事.由于即便,但是地址空间却不是同一块.例如: 所以为了便利操作以及避免一些过错,&lt;所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYL1y4.html" rel="bookmark" class="title">计算机性能</a>
					<div>
						计算机网络在我国的发展 中国是1994年4月20正式接入互联网,现在网名特别多,又是一个商机,尤其是手机用户. 计算机网络的类别,广域网,家里连接的,租用人家的服务,就是广域网,用的人家的技术. 局域 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPbgdM.html" rel="bookmark" class="title">OGNL表达式语言网上转来的</a>
					<div>
						1.概念:OGNL是ObjectGraphic Navigation Language(对象图导航语言)的缩写,它是一个开源项目. Struts 2框架使用OGNL作为默认的表达式语言. 2.功能:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrWvm4.html" rel="bookmark" class="title">javaScript for循环</a>
					<div>
						for(语句1;语句2;语句3){ //被执行的代码块; } 语句1: 在循环开始前执行; 语句2: 定义运行循环的条件; 语句3: 在循环已被执行之后执行; 通常说,语句1.2.3都是可选的 语句2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xByz74.html" rel="bookmark" class="title">近期SQL优化总结</a>
					<div>
						近期做SQL优化,发现了一些问题,感觉还是有必要拉出来说说的,不涉及多么高深的技术问题.或者与技术没多大关系,大多都是思想认识的问题,多想想多看看应该都会解决的. 当然这里有个成本和效益的问题,某些年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nevYvM.html" rel="bookmark" class="title">关于Hibernate的查询从数据库映射到JavaBean</a>
					<div>
						Hibernate除了HQL外,还支持SQL的查询,API为createSQLQuery(sql),如果数据库使用的是Oracle,由于数据库表中的列都是大写,所以在从resultset到javabe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzk9Bl0.html" rel="bookmark" class="title">linux：磁碟与档案系统管理</a>
					<div>
						档案系统特性:为什么磁碟分割完需要格式化(format)才能使用吗? 答:因为因为每种作业系统锁设定的档案属性和权限并不相同,为了存放这些档案所需的资料(所以需要格式化成作业系统能够利用的档案系统格式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NXaa20.html" rel="bookmark" class="title">Javascript 异步编程的4种方法</a>
					<div>
						你可能知道,Javascript语言的执行环境是&quot;单线程&quot;(single thread). 所谓&quot;单线程&quot;,就是指一次只能完成一件任务.如果有多个任务,就必须排 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDl1LwM.html" rel="bookmark" class="title">错误简单记录</a>
					<div>
						下列错误 主要是由于 标识 自增长 和 主键约束等造成的 标识概念1.标识了就不允许为空,不标识就允许为空2.标识了就从默认的值开始(假如种子是1000,增量是2),每增加一条记录,那条记录的id就加 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
